<?php
if (!class_exists('TS_Image_Hover_Effects')){
	class TS_Image_Hover_Effects {
		function __construct() {
            if (function_exists('vc_is_inline')){
                if (vc_is_inline()) {
                    add_action('init',                                  array($this, 'TS_VCSC_Image_Hover_Effects_Elements'), 9999999);
                } else {
                    add_action('admin_init',		                    array($this, 'TS_VCSC_Image_Hover_Effects_Elements'), 9999999);
                }
            } else {
                add_action('admin_init',                                array($this, 'TS_VCSC_Image_Hover_Effects_Elements'), 9999999);
            }
            add_shortcode('TS_VCSC_Image_Hover_Effects',				array($this, 'TS_VCSC_Image_Hover_Effects_Function'));
		}
        
        // Image Hover Effects
        function TS_VCSC_Image_Hover_Effects_Function ($atts, $content = null) {
            global $VISUAL_COMPOSER_EXTENSIONS;
            ob_start();
			
			// Check for Front End Editor
            if (function_exists('vc_is_inline')){
                if (vc_is_inline()) {
					$hover_frontent			= "true";
                } else {
					$hover_frontent			= "false";
                }
            } else {
				$hover_frontent				= "false";
            }

			if ($hover_frontent == "false") {
				wp_enqueue_script('ts-extend-hammer');
				wp_enqueue_script('ts-extend-nacho');
				wp_enqueue_style('ts-extend-nacho');
			}	
            if ($VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_LoadFrontEndForcable == "false") {
				wp_enqueue_style('ts-extend-tooltipster');
				wp_enqueue_script('ts-extend-tooltipster');	
                wp_enqueue_style('ts-extend-hovereffects');
				wp_enqueue_script('ts-extend-badonkatrunc');
				wp_enqueue_style('ts-font-teammates');
                wp_enqueue_style('ts-visual-composer-extend-front');
                wp_enqueue_script('ts-visual-composer-extend-front');
            }
            
            extract( shortcode_atts( array(
                'hover_image'					=> '',
				'hover_responsive'				=> 'true',
				'hover_truncate'				=> 'false',
				
				'effect_style_type'				=> 'text',
				'effect_style_text'				=> 'ts-hover-effect-lily',
				'effect_style_icons'			=> 'ts-hover-effect-hera',
				
				'title_text'					=> '',
				'title_color'					=> '#ffffff',				
				'content_text'					=> '',
				'content_color_text'			=> '#ffffff',
				'content_color_icons'			=> '#000000',
				'content_color_other'			=> '#ffffff',
				
				'content_icons'					=> '',
				'content_link1'					=> '',
				'content_link1_icon'			=> '',
				'content_link2'					=> '',
				'content_link2_icon'			=> '',
				'content_link3'					=> '',
				'content_link3_icon'			=> '',
				'content_link4'					=> '',
				'content_link4_icon'			=> '',

				'hover_event'					=> 'none',
				'hover_show_title'				=> 'true',
				'hover_link'					=> '',
				'hover_text'					=> '',
				'hover_image'					=> '',
				'hover_link'					=> '',				
				'hover_video_link'				=> '',
				'hover_video_auto'				=> 'true',
				'hover_video_related'			=> 'false',				
				
				'overlay_trigger'				=> 'ts-trigger-hover',
				'overlay_handle_show'			=> 'true',
				'overlay_handle_color'			=> '#0094FF',
				
				'tooltip_html'					=> 'false',
				'tooltip_content'				=> '',
				'tooltip_content_html'			=> '',
				'tooltip_position'				=> 'ts-simptip-position-top',
				'tooltip_style'					=> '',
				'tooltipster_offsetx'			=> 0,
				'tooltipster_offsety'			=> 0,
				
				'lightbox_group'				=> 'false',
				'lightbox_group_name'			=> '',
				'lightbox_size'					=> 'full',
				'lightbox_effect'				=> 'random',
				'lightbox_speed'				=> 5000,
				'lightbox_social'				=> 'true',
				'lightbox_backlight_choice'		=> 'predefined',
				'lightbox_backlight_color'		=> '#0084E2',
				'lightbox_backlight_custom'		=> '#000000',
				
				'lightbox_custom_padding'		=> 15,
				'lightbox_custom_background'	=> 'none',
				'lightbox_background_image'		=> '',
				'lightbox_background_size'		=> 'cover',
				'lightbox_background_repeat'	=> 'no-repeat',
				'lightbox_background_color'		=> '#ffffff',
				
                'margin_top'					=> 0,
                'margin_bottom'					=> 0,
                'el_id' 						=> '',
                'el_class'              		=> '',
				'css'							=> '',
            ), $atts ));
            
            $output                             = '';
			$linkString							= '';
        
            if (!empty($el_id)) {
                $hover_image_id					= $el_id;
            } else {
                $hover_image_id					= 'ts-vcsc-hover-effects-' . mt_rand(999999, 9999999);
            }
			
			// Effect Style
			if ($effect_style_type == "text") {
				$effect_style					= $effect_style_text;
			} else {
				$effect_style					= $effect_style_icons;
			}			
			// Image
			if (!empty($hover_image)) {
				$hover_image					= wp_get_attachment_image_src($hover_image, 'full');
			}
			// Content Icon Links
			$link_content1 						= ($content_link1 == '||') ? '' : $content_link1;
			$link_content1 						= vc_build_link($link_content1);
			$a_href_content1					= $link_content1['url'];
			$a_title_content1 					= $link_content1['title'];
			$a_target_content1 					= $link_content1['target'];			
			$link_content2 						= ($content_link2 == '||') ? '' : $content_link2;
			$link_content2 						= vc_build_link($link_content2);
			$a_href_content2					= $link_content2['url'];
			$a_title_content2 					= $link_content2['title'];
			$a_target_content2 					= $link_content2['target'];
			$link_content3 						= ($content_link3 == '||') ? '' : $content_link3;
			$link_content3 						= vc_build_link($link_content3);
			$a_href_content3					= $link_content3['url'];
			$a_title_content3 					= $link_content3['title'];
			$a_target_content3 					= $link_content3['target'];
			$link_content4 						= ($content_link4 == '||') ? '' : $content_link4;
			$link_content4 						= vc_build_link($link_content4);
			$a_href_content4					= $link_content4['url'];
			$a_title_content4 					= $link_content4['title'];
			$a_target_content4 					= $link_content4['target'];			
			// iFrame / Link
			if (($hover_event == "link") || ($hover_event == "iframe")) {
				$link 							= ($hover_link == '||') ? '' : $hover_link;
				$link 							= vc_build_link($link);
				$a_href							= $link['url'];
				$a_title 						= '';
				$a_target 						= $link['target'];
			} else {
				$a_href							= 'javascript:void(0);';
				$a_title						= '';
				$a_target						= '_blank';
			}
			if ($a_href == '') {
				$a_href							= 'javascript:void(0);';
			}		
			// YouTube Video
			if ($hover_event == "youtube") {
				if (preg_match('~((http|https|ftp|ftps)://|www.)(.+?)~', $hover_video_link)) {
					$hover_video_link		= $hover_video_link;
				} else {
					$hover_video_link		= 'https://www.youtube.com/watch?v=' . $hover_video_link;
				}
			}
			// DailyMotion Video
			if ($hover_event == "dailymotion") {
				if (preg_match('~((http|https|ftp|ftps)://|www.)(.+?)~', $hover_video_link)) {
					$hover_video_link	= $hover_video_link;
				} else {			
					$hover_video_link	= $hover_video_link;
				}
			}
			
			// Backlight Color
			if ($lightbox_backlight_choice == "predefined") {
				$lightbox_backlight_selection	= $lightbox_backlight_color;
			} else {
				$lightbox_backlight_selection	= $lightbox_backlight_custom;
			}
	
			// Custom Width / Height
			$lightbox_dimensions				= '';
			
			// Background Settings
			if ($lightbox_custom_background == "image") {
				$background_image 				= wp_get_attachment_image_src($lightbox_background_image, 'full');
				$background_image 				= $background_image[0];
				$lightbox_background			= 'background: url(' . $background_image . ') ' . $lightbox_background_repeat . ' 0 0; background-size: ' . $lightbox_background_size . ';';
			} else if ($lightbox_custom_background == "color") {
				$lightbox_background			= 'background: ' . $lightbox_background_color . ';';
			} else {
				$lightbox_background			= '';
			}
			
			// Handle Padding
			if ($overlay_handle_show == "true") {
				$overlay_padding				= "padding-bottom: 25px;";
				$switch_handle_adjust  			= "";
			} else {
				$overlay_padding				= "";
				$switch_handle_adjust  			= "";
			}
			
			// Handle Icon
			if ($hover_event != "none") {
				$switch_handle_icon				= 'handle_click';
			} else {
				$switch_handle_icon				= 'handle_hover';
			}
			
			// Link Output
			if ($hover_frontent == "false") {
				if (($hover_event != "none") && ($hover_event == "popup")) {
					// Modal Popup
					$linkString .= '<a id="' . $hover_image_id . '-trigger" href="#' . $hover_image_id . '" class="ts-hover-image-link ' . $hover_image_id . '-parent nch-holder nch-lightbox-modal" ' . $lightbox_dimensions . ' style="" data-title="' . $title_text . '" data-type="html" rel="' . ($lightbox_group == "true" ? "nachogroup" : $lightbox_group_name) . '" data-effect="' . $lightbox_effect . '" data-share="' . ($lightbox_social == "true" ? 1 : 0) . '" data-duration="' . $lightbox_speed . '" data-color="' . $lightbox_backlight_selection . '">View</a>';
				} else if (($hover_event != "none") && ($hover_event == "iframe")) {
					// iFrame Popup
					$linkString .= '<a id="' . $hover_image_id . '-trigger" href="' . $a_href . '" target="' . $a_target . '" class="ts-hover-image-link ' . $hover_image_id . '-parent nch-holder nch-lightbox-media" ' . $lightbox_dimensions . ' style="" data-title="' . $title_text . '" data-type="iframe" rel="' . ($lightbox_group == "true" ? "nachogroup" : $lightbox_group_name) . '" data-effect="' . $lightbox_effect . '" data-share="' . ($lightbox_social == "true" ? 1 : 0) . '" data-duration="' . $lightbox_speed . '" data-color="' . $lightbox_backlight_selection . '">View</a>';
				} else if (($hover_event != "none") && ($hover_event == "image")) {
					// Image Popup
					$linkString .= '<a id="' . $hover_image_id . '-trigger" href="' . $hover_image[0] . '" class="ts-hover-image-link ' . $hover_image_id . '-parent nch-holder nch-lightbox-media" ' . $lightbox_dimensions . ' style="" data-title="' . $title_text . '" rel="' . ($lightbox_group == "true" ? "nachogroup" : $lightbox_group_name) . '" data-effect="' . $lightbox_effect . '" data-share="' . ($lightbox_social == "true" ? 1 : 0) . '" data-duration="' . $lightbox_speed . '" data-color="' . $lightbox_backlight_selection . '">View</a>';
				} else if (($hover_event != "none") && ($hover_event == "youtube")) {
					// YouTube Popup
					$linkString .= '<a id="' . $hover_image_id . '-trigger" href="' . $hover_video_link .'" class="ts-hover-image-link ' . $hover_image_id . '-parent nch-holder nch-lightbox-media" ' . $lightbox_dimensions . ' style="" data-title="' . $title_text . '" data-related="' . $hover_video_related .'" data-videoplay="' . $hover_video_auto .'" data-type="youtube" rel="' . ($lightbox_group == "true" ? "nachogroup" : $lightbox_group_name) . '" data-effect="' . $lightbox_effect . '" data-share="' . ($lightbox_social == "true" ? 1 : 0) . '" data-duration="' . $lightbox_speed . '" data-color="' . $lightbox_backlight_selection . '">View</a>';
				} else if (($hover_event != "none") && ($hover_event == "vimeo")) {
					// Vimeo Popup
					$linkString .= '<a id="' . $hover_image_id . '-trigger" href="' . $hover_video_link . '" class="ts-hover-image-link ' . $hover_image_id . '-parent nch-holder nch-lightbox-media" ' . $lightbox_dimensions . ' style="" data-title="' . $title_text . '" data-videoplay="' . $hover_video_auto . '" data-type="vimeo" rel="' . ($lightbox_group == "true" ? "nachogroup" : $lightbox_group_name) . '" data-effect="' . $lightbox_effect . '" data-share="' . ($lightbox_social == "true" ? 1 : 0) . '" data-duration="' . $lightbox_speed . '" data-color="' . $lightbox_backlight_selection . '">View</a>';
				} else if (($hover_event != "none") && ($hover_event == "dailymotion")) {
					// DailyMotion Popup
					$linkString .= '<a id="' . $hover_image_id . '-trigger" href="' . $hover_video_link .'" class="ts-hover-image-link ' . $hover_image_id . '-parent nch-holder nch-lightbox-media" ' . $lightbox_dimensions . ' style="" data-title="' . $title_text . '" data-videoplay="' . $hover_video_auto . '" data-type="dailymotion" rel="' . ($lightbox_group == "true" ? "nachogroup" : $lightbox_group_name) . '" data-effect="' . $lightbox_effect . '" data-share="' . ($lightbox_social == "true" ? 1 : 0) . '" data-duration="' . $lightbox_speed . '" data-color="' . $lightbox_backlight_selection . '">View</a>';
				} else if (($hover_event != "none") && ($hover_event == "html5")) {
					// HTML5 Video Popup
					$linkString .= '<a id="' . $hover_image_id . '-trigger" href="#' . $modal_id . '" class="ts-hover-image-link ' . $hover_image_id . '-parent nch-holder nch-lightbox-media" ' . $lightbox_dimensions . ' style="" data-title="' . $title_text . '" data-type="html" rel="' . ($lightbox_group == "true" ? "nachogroup" : $lightbox_group_name) . '" data-effect="' . $lightbox_effect . '" data-share="' . ($lightbox_social == "true" ? 1 : 0) . '" data-duration="' . $lightbox_speed . '" data-color="' . $lightbox_backlight_selection . '">View</a>';
				} else if (($hover_event != "none") && ($hover_event == "link")) {
					// Link Event
					$linkString .= '<a id="' . $hover_image_id . '-trigger" class="ts-hover-image-link" href="' . $a_href . '" target="' . $a_target . '" title="' . $a_title . '">View</a>';
				} else {
					// No Link Event
					$linkString .= '';
				}
			} else {
				$linkString 	.= '';
			}
			
			// Tooltip
			if (($tooltip_position == "ts-simptip-position-top") || ($tooltip_position == "top")) {
				$tooltip_position			= "top";
			}
			if (($tooltip_position == "ts-simptip-position-left") || ($tooltip_position == "left")) {
				$tooltip_position			= "left";
			}
			if (($tooltip_position == "ts-simptip-position-right") || ($tooltip_position == "right")) {
				$tooltip_position			= "right";
			}
			if (($tooltip_position == "ts-simptip-position-bottom") || ($tooltip_position == "bottom")) {
				$tooltip_position			= "bottom";
			}
			$tooltip_class					= 'ts-has-tooltipster-tooltip';		
			if (($tooltip_style == "") || ($tooltip_style == "ts-simptip-style-black") || ($tooltip_style == "tooltipster-black")) {
				$tooltip_style				= "tooltipster-black";
			}
			if (($tooltip_style == "ts-simptip-style-gray") || ($tooltip_style == "tooltipster-gray")) {
				$tooltip_style				= "tooltipster-gray";
			}
			if (($tooltip_style == "ts-simptip-style-green") || ($tooltip_style == "tooltipster-green")) {
				$tooltip_style				= "tooltipster-green";
			}
			if (($tooltip_style == "ts-simptip-style-blue") || ($tooltip_style == "tooltipster-blue")) {
				$tooltip_style				= "tooltipster-blue";
			}
			if (($tooltip_style == "ts-simptip-style-red") || ($tooltip_style == "tooltipster-red")) {
				$tooltip_style				= "tooltipster-red";
			}
			if (($tooltip_style == "ts-simptip-style-orange") || ($tooltip_style == "tooltipster-orange")) {
				$tooltip_style				= "tooltipster-orange";
			}
			if (($tooltip_style == "ts-simptip-style-yellow") || ($tooltip_style == "tooltipster-yellow")) {
				$tooltip_style				= "tooltipster-yellow";
			}
			if (($tooltip_style == "ts-simptip-style-purple") || ($tooltip_style == "tooltipster-purple")) {
				$tooltip_style				= "tooltipster-purple";
			}
			if (($tooltip_style == "ts-simptip-style-pink") || ($tooltip_style == "tooltipster-pink")) {
				$tooltip_style				= "tooltipster-pink";
			}
			if (($tooltip_style == "ts-simptip-style-white") || ($tooltip_style == "tooltipster-white")) {
				$tooltip_style				= "tooltipster-white";
			}
			if ($tooltip_html == "true") {
				if (strlen($tooltip_content_html) != 0) {
					$Tooltip_Content		= 'data-tooltipster-title="" data-tooltipster-text="' . rawurldecode(base64_decode(strip_tags($tooltip_content_html))) . '" data-tooltipster-image="" data-tooltipster-position="' . $tooltip_position . '" data-tooltipster-touch="false" data-tooltipster-arrow="true" data-tooltipster-theme="' . $tooltip_style . '" data-tooltipster-animation="swing" data-tooltipster-trigger="hover" data-tooltipster-offsetx="' . $tooltipster_offsetx . '" data-tooltipster-offsety="' . $tooltipster_offsety . '"';
					$Tooltip_Class			= $tooltip_class;
				} else {
					$Tooltip_Content		= '';
					$Tooltip_Class			= '';
				}
			} else {
				if (strlen($tooltip_content) != 0) {
					$Tooltip_Content		= 'data-tooltipster-title="" data-tooltipster-text="' . $tooltip_content . '" data-tooltipster-image="" data-tooltipster-position="' . $tooltip_position . '" data-tooltipster-touch="false" data-tooltipster-arrow="true" data-tooltipster-theme="' . $tooltip_style . '" data-tooltipster-animation="swing" data-tooltipster-trigger="hover" data-tooltipster-offsetx="' . $tooltipster_offsetx . '" data-tooltipster-offsety="' . $tooltipster_offsety . '"';
					$Tooltip_Class			= $tooltip_class;
				} else {
					$Tooltip_Content		= '';
					$Tooltip_Class			= '';
				}
			}
			
			$output .= '<div class="ts-hover-effects-container ts-image-effects-frame ts-image-hover-frame" style="margin-top: ' . $margin_top . 'px; margin-bottom: ' . $margin_bottom . 'px;">';
				if ((strlen($tooltip_content_html) != 0) || (strlen($tooltip_content) != 0)) {
					$output .= '<div class="' . $Tooltip_Class . '" ' . $Tooltip_Content . ' style="width: 100%; height: 100%;">';
				}
					if ($overlay_handle_show == "true") {
						$output .= '<div class="" style="' . $overlay_padding . '">';
					}				
						$output .= '<div class="ts-hover-effects-grid">';					
							$output .= '<figure class="' . $effect_style . '">';
								$output .= '<img src="' . $hover_image[0] . '" data-width="' . $hover_image[1] . '" data-height="' . $hover_image[2] . '" data-ratio="' . ($hover_image[1] / $hover_image[2]) . '" alt=""/>';
								$output .= '<figcaption class="ts-hover-effects-figcaption">';
									if (($effect_style == "ts-hover-effect-lily") || ($effect_style == "ts-hover-effect-julia")) {
										$output .= '<div>';
									}
										$output .= '<h2 style="color: ' . $title_color . '">' . $title_text . '</h2>';
										if (($effect_style != "ts-hover-effect-zoe") && ($effect_style != "ts-hover-effect-hera") && ($effect_style != "ts-hover-effect-winston") && ($effect_style != "ts-hover-effect-terry") && ($effect_style != "ts-hover-effect-kira")) {
											$output .= '<p style="color: ' . $content_color_text . '">' . $content_text . '</p>';
										}
										if ($effect_style == "ts-hover-effect-zoe") {
											$output .= '<p class="icon-links" style="color: ' . $content_color_icons . '">';
												if (($a_href_content1 != "") && ($content_link1_icon != "")) {
													$output .= '<a href="' . $a_href_content1 . '" target="' . $a_target_content1 . '" title="' . $a_title_content1 . '"><span style="color: ' . $content_color_icons . '" class="ts-teammate-icon ' . $content_link1_icon . '"></span></a>';
												}
												if (($a_href_content2 != "") && ($content_link2_icon != "")) {
													$output .= '<a href="' . $a_href_content2 . '" target="' . $a_target_content2 . '" title="' . $a_title_content2 . '"><span style="color: ' . $content_color_icons . '" class="ts-teammate-icon ' . $content_link2_icon . '"></span></a>';
												}
												if (($a_href_content3 != "") && ($content_link3_icon != "")) {
													$output .= '<a href="' . $a_href_content3 . '" target="' . $a_target_content3 . '" title="' . $a_title_content3 . '"><span style="color: ' . $content_color_icons . '" class="ts-teammate-icon ' . $content_link3_icon . '"></span></a>';
												}
											$output .= '</p>';
											$output .= '<p class="description" style="color: ' . $content_color_other . '">' . $content_icons . '</p>';
										}
										if (($effect_style == "ts-hover-effect-hera") || ($effect_style == "ts-hover-effect-terry") || ($effect_style == "ts-hover-effect-kira")) {
											$output .= '<p style="color: ' . $content_color_icons . '">';
												if (($a_href_content1 != "") && ($content_link1_icon != "")) {
													$output .= '<a href="' . $a_href_content1 . '" target="' . $a_target_content1 . '" title="' . $a_title_content1 . '"><i style="color: ' . $content_color_icons . '" class="ts-teammate-icon ' . $content_link1_icon . '"></i></a>';
												}
												if (($a_href_content2 != "") && ($content_link2_icon != "")) {
													$output .= '<a href="' . $a_href_content2 . '" target="' . $a_target_content2 . '" title="' . $a_title_content2 . '"><i style="color: ' . $content_color_icons . '" class="ts-teammate-icon ' . $content_link2_icon . '"></i></a>';
												}
												if (($a_href_content3 != "") && ($content_link3_icon != "")) {
													$output .= '<a href="' . $a_href_content3 . '" target="' . $a_target_content3 . '" title="' . $a_title_content3 . '"><i style="color: ' . $content_color_icons . '" class="ts-teammate-icon ' . $content_link3_icon . '"></i></a>';
												}
												if (($a_href_content4 != "") && ($content_link4_icon != "")) {
													$output .= '<a href="' . $a_href_content4 . '" target="' . $a_target_content4 . '" title="' . $a_title_content4 . '"><i style="color: ' . $content_color_icons . '" class="ts-teammate-icon ' . $content_link4_icon . '"></i></a>';
												}
											$output .= '</p>';
										}
										if (($effect_style == "ts-hover-effect-winston") || ($effect_style == "ts-hover-effect-phoebe")) {
											$output .= '<p style="color: ' . $content_color_icons . '">';
												if (($a_href_content1 != "") && ($content_link1_icon != "")) {
													$output .= '<a href="' . $a_href_content1 . '" target="' . $a_target_content1 . '" title="' . $a_title_content1 . '"><i style="color: ' . $content_color_icons . '" class="ts-teammate-icon ' . $content_link1_icon . '"></i></a>';
												}
												if (($a_href_content2 != "") && ($content_link2_icon != "")) {
													$output .= '<a href="' . $a_href_content2 . '" target="' . $a_target_content2 . '" title="' . $a_title_content2 . '"><i style="color: ' . $content_color_icons . '" class="ts-teammate-icon ' . $content_link2_icon . '"></i></a>';
												}
												if (($a_href_content3 != "") && ($content_link3_icon != "")) {
													$output .= '<a href="' . $a_href_content3 . '" target="' . $a_target_content3 . '" title="' . $a_title_content3 . '"><i style="color: ' . $content_color_icons . '" class="ts-teammate-icon ' . $content_link3_icon . '"></i></a>';
												}
											$output .= '</p>';
										}
									if (($effect_style == "ts-hover-effect-lily") || ($effect_style == "ts-hover-effect-julia")) {
										$output .= '</div>';
									}
									if (($effect_style != "ts-hover-effect-zoe") && ($effect_style != "ts-hover-effect-hera") && ($effect_style != "ts-hover-effect-winston") && ($effect_style != "ts-hover-effect-terry") && ($effect_style != "ts-hover-effect-kira")) {
										$output .= $linkString;
									}
								$output .= '</figcaption>';	
							$output .= '</figure>';
						$output .= '</div>';				
						if ($overlay_handle_show == "true") {
							$output .= '<div class="ts-image-hover-handle" style="' . $switch_handle_adjust . '"><span class="frame_' . $switch_handle_icon . '" style="background-color: ' . $overlay_handle_color . '"><i class="' . $switch_handle_icon . '"></i></span></div>';
						}
					if ($overlay_handle_show == "true") {
						$output .= '</div>';
					}
				if ((strlen($tooltip_content_html) != 0) || (strlen($tooltip_content) != 0)) {
					$output .= '</div>';
				}
				// Create hidden DIV with Modal Popup Hover Content
				if (($hover_frontent == "false") && ($hover_event == "popup")) {
					$output .= '<div id="' . $hover_image_id . '" class="ts-modal-content nch-hide-if-javascript ' . $el_class . '" style="display: none; padding: ' . $lightbox_custom_padding . 'px; ' . $lightbox_background . '">';
						$output .= '<div class="ts-modal-white-header"></div>';
						$output .= '<div class="ts-modal-white-frame" style="">';
							$output .= '<div class="ts-modal-white-inner">';
								if (($hover_show_title == "true") && ($title_text != "")) {
									$output .= '<h2 style="border-bottom: 1px solid #eeeeee; padding-bottom: 10px; margin-bottom: 10px;">' . $title_text . '</h2>';
								}
								$output .= rawurldecode(base64_decode(strip_tags($hover_text)));
							$output .= '</div>';
						$output .= '</div>';
					$output .= '</div>';
				}
			$output .= '</div>';
			
            echo $output;
            
            $myvariable = ob_get_clean();
            return $myvariable;
        }    
		// Add Image Hover Effects Elements
        function TS_VCSC_Image_Hover_Effects_Elements() {
            global $VISUAL_COMPOSER_EXTENSIONS;
			// Define some Arrays
			$this->TS_VCSC_HoverEffectsIconsSelection = array(
				""										=> "",
				"teamicon-email10" 						=> "Email",
				"teamicon-link6"						=> "Link",
				"teamicon-portfolio"					=> "Portfolio",
				"teamicon-download7" 					=> "Download",				
				"teamicon-star"							=> "Star1",
				"teamicon-star2"						=> "Star2",
				"teamicon-star2"						=> "Star2",				
				"teamicon-heart"						=> "Heart1",
				"teamicon-heart2"						=> "Heart2",
				"teamicon-heart-broken"					=> "Heart3",				
				"teamicon-thumbs-up2"					=> "Thumbs1",
				"teamicon-thumbs-up"					=> "Thumbs2",				
				"teamicon-tag"							=> "Tag",
				"teamicon-tags"							=> "Tags",				
				"teamicon-cog"							=> "Cog1",
				"teamicon-cogs"							=> "Cog2",
				"teamicon-cog2"							=> "Cog3",				
				"teamicon-home"							=> "Home1",
				"teamicon-home2"						=> "Home2",
				"teamicon-home3"						=> "Home3",				
				"teamicon-user"							=> "User1",
				"teamicon-user2"						=> "User2",
				"teamicon-user3"						=> "User3",
				"teamicon-user4"						=> "User4",				
				"teamicon-users"						=> "Users1",
				"teamicon-users2"						=> "Users2",				
				"teamicon-eye5"							=> "Eye",
				"teamicon-info3"						=> "Info",
				"teamicon-calendar1"					=> "Calendar",
				"teamicon-clock1"						=> "Clock",
				"teamicon-location1"					=> "Location",
				"teamicon-file11"						=> "Word",
				"teamicon-file10"						=> "Excel",
				"teamicon-file13"						=> "PDF",
				"teamicon-file15"						=> "Blank",
				"teamicon-wikipedia"					=> "Wikipedia",
				"teamicon-facebook1"					=> "Facebook",
				"teamicon-twitter4"						=> "Twitter",
				"teamicon-googleplus1"					=> "Google",
			);
            // Add IHover Element
            if (function_exists('vc_map')) {
                vc_map( array(
                    "name"                              => __( "TS Image Advanced Overlay", "ts_visual_composer_extend" ),
                    "base"                              => "TS_VCSC_Image_Hover_Effects",
                    "icon" 	                            => "icon-wpb-ts_vcsc_image_hovereffects",
                    "class"                             => "",
                    "category"                          => __( 'VC Extensions', "ts_visual_composer_extend" ),
                    "description"                       => __("Place an image with Hover effects", "ts_visual_composer_extend"),
					"admin_enqueue_js"            		=> "",
					"admin_enqueue_css"           		=> "",
                    "params"                            => array(
                        // Style Selection
                        array(
                            "type"                      => "seperator",
                            "heading"                   => __( "", "ts_visual_composer_extend" ),
                            "param_name"                => "seperator_1",
							"value"						=> "",
                            "seperator"					=> "Hover Selection",
                            "description"               => __( "", "ts_visual_composer_extend" )
                        ),
						array(
							"type"                  	=> "attach_image",
							"holder" 					=> ($VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_EditorImagePreview == "true" ? "img" : ""),
							"heading"               	=> __( "Image", "ts_visual_composer_extend" ),
							"param_name"            	=> "hover_image",
							"class"						=> "ts_vcsc_holder_image",
							"value"                 	=> "",
							"admin_label"       		=> ($VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_EditorImagePreview == "true" ? false : true),
							"description"           	=> __( "Select the image you want to use with the Hover effect.", "ts_visual_composer_extend" )
						),
						array(
							"type"				    	=> "dropdown",
							"class"				    	=> "",
							"heading"			    	=> __( "Effect Style", "ts_visual_composer_extend" ),
							"param_name"		    	=> "effect_style_type",
							"value"                 	=> array(
								__("Overlay with Text", "ts_visual_composer_extend")	=> "text",
								__("Overlay with Icons", "ts_visual_composer_extend")	=> "icons",
							),
							"description"		    	=> __( "Select the general style for the Hover effect.", "ts_visual_composer_extend" ),
							"admin_label"       		=> true,
							"dependency"		    	=> "",
						),
						array(
							"type"				    	=> "dropdown",
							"class"				    	=> "",
							"heading"			    	=> __( "Text Style", "ts_visual_composer_extend" ),
							"param_name"		    	=> "effect_style_text",
							"value"                 	=> array(
								__("Nice Lily", "ts_visual_composer_extend")			=> "ts-hover-effect-lily",
								__("Holy Sadie", "ts_visual_composer_extend")			=> "ts-hover-effect-sadie",
								__("Dreamy Honey", "ts_visual_composer_extend")			=> "ts-hover-effect-honey",
								__("Crazy Layla", "ts_visual_composer_extend")			=> "ts-hover-effect-layla",								
								__("Warm Oscar", "ts_visual_composer_extend")			=> "ts-hover-effect-oscar",
								__("Sweet Marley", "ts_visual_composer_extend")			=> "ts-hover-effect-marley",
								__("Glowing Ruby", "ts_visual_composer_extend")			=> "ts-hover-effect-ruby",
								__("Charming Roxy", "ts_visual_composer_extend")		=> "ts-hover-effect-roxy",
								__("Fresh Bubba", "ts_visual_composer_extend")			=> "ts-hover-effect-bubba",
								__("Wild Romeo", "ts_visual_composer_extend")			=> "ts-hover-effect-romeo",
								__("Strange Dexter", "ts_visual_composer_extend")		=> "ts-hover-effect-dexter",
								__("Free Sarah", "ts_visual_composer_extend")			=> "ts-hover-effect-sarah",
								__("Silly Chico", "ts_visual_composer_extend")			=> "ts-hover-effect-chico",
								__("Faithful Milo", "ts_visual_composer_extend")		=> "ts-hover-effect-milo",
								__("Passionate Julia", "ts_visual_composer_extend")		=> "ts-hover-effect-julia",
								__("Thoughtful Goliath", "ts_visual_composer_extend")	=> "ts-hover-effect-goliath",
								__("Happy Selena", "ts_visual_composer_extend")			=> "ts-hover-effect-selena",
								__("Strong Apollo", "ts_visual_composer_extend")		=> "ts-hover-effect-apollo",
								__("Lonely Steve", "ts_visual_composer_extend")			=> "ts-hover-effect-steve",
								__("Cute Moses", "ts_visual_composer_extend")			=> "ts-hover-effect-moses",
								__("Dynamic Jazz", "ts_visual_composer_extend")			=> "ts-hover-effect-jazz",
								__("Funny Ming", "ts_visual_composer_extend")			=> "ts-hover-effect-ming",
								__("Altruistic Lexi", "ts_visual_composer_extend")		=> "ts-hover-effect-lexi",
								__("Messy Duke", "ts_visual_composer_extend")			=> "ts-hover-effect-duke",
							),
							"description"		    	=> __( "Select the general style for the Hover effect.", "ts_visual_composer_extend" ),
							"admin_label"       		=> true,
							"dependency"            	=> array( 'element' => "effect_style_type", 'value' => 'text' ),
						),
						array(
							"type"				    	=> "dropdown",
							"class"				    	=> "",
							"heading"			    	=> __( "Icon Style", "ts_visual_composer_extend" ),
							"param_name"		    	=> "effect_style_icons",
							"value"                 	=> array(
								__("Creative Zoe", "ts_visual_composer_extend")			=> "ts-hover-effect-zoe",
								__("Tender Hera", "ts_visual_composer_extend")			=> "ts-hover-effect-hera",
								__("Jolly Winston", "ts_visual_composer_extend")		=> "ts-hover-effect-winston",
								__("Noisy Terry", "ts_visual_composer_extend")			=> "ts-hover-effect-terry",
								__("Plain Pheobe", "ts_visual_composer_extend")			=> "ts-hover-effect-phoebe",
								__("Dark Kira", "ts_visual_composer_extend")			=> "ts-hover-effect-kira",
							),
							"description"		    	=> __( "Select the general style for the Hover effect.", "ts_visual_composer_extend" ),
							"admin_label"       		=> true,
							"dependency"            	=> array( 'element' => "effect_style_type", 'value' => 'icons' ),
						),
						// Content Settings
                        array(
                            "type"                      => "seperator",
                            "heading"                   => __( "", "ts_visual_composer_extend" ),
                            "param_name"                => "seperator_2",
							"value"						=> "",
                            "seperator"					=> "Hover Content",
                            "description"               => __( "", "ts_visual_composer_extend" ),
							"group" 			        => "Content",
                        ),
						array(
							"type"						=> "textfield",
							"heading"					=> __( "Title", "ts_visual_composer_extend" ),
							"param_name"				=> "title_text",
							"value"						=> "",
							"admin_label"       		=> true,
							"description"				=> __( "Enter a title to be used for the Hover effect.", "ts_visual_composer_extend" ),
							"group" 			        => "Content",
						),
						array(
							"type"                  	=> "colorpicker",
							"heading"              	 	=> __( "Title Color", "ts_visual_composer_extend" ),
							"param_name"            	=> "title_color",
							"value"                 	=> "#ffffff",
							"description"           	=> __( "Define the color for the title text.", "ts_visual_composer_extend" ),
							"dependency"            	=> "",
							"group" 			        => "Content",
						),
						array(
							"type"                  	=> "textarea",
							"class"                 	=> "",
							"heading"               	=> __( "Message", "ts_visual_composer_extend" ),
							"param_name"            	=> "content_text",
							"value"                 	=> "",
							"description"	        	=> __( "Enter a short message to be used for the Hover effect; HTML code can NOT be used.", "ts_visual_composer_extend" ),
							"dependency"            	=> array( 'element' => "effect_style_type", 'value' => 'text' ),
							"group" 					=> "Content",
						),
						array(
							"type"                  	=> "textarea",
							"class"                 	=> "",
							"heading"               	=> __( "Message", "ts_visual_composer_extend" ),
							"param_name"            	=> "content_icons",
							"value"                 	=> "",
							"description"	        	=> __( "Enter a short message to be used for the Hover effect; HTML code can NOT be used.", "ts_visual_composer_extend" ),
							"dependency"            	=> array( 'element' => "effect_style_icons", 'value' => 'ts-hover-effect-zoe' ),
							"group" 					=> "Content",
						),
						array(
							"type"                  	=> "colorpicker",
							"heading"              	 	=> __( "Message Color", "ts_visual_composer_extend" ),
							"param_name"            	=> "content_color_text",
							"value"                 	=> "#ffffff",
							"description"           	=> __( "Define the color for the content text.", "ts_visual_composer_extend" ),
							"dependency"            	=> array( 'element' => "effect_style_type", 'value' => 'text' ),
							"group" 			        => "Content",
						),
						array(
							"type"                  	=> "colorpicker",
							"heading"              	 	=> __( "Message Color", "ts_visual_composer_extend" ),
							"param_name"            	=> "content_color_other",
							"value"                 	=> "#ffffff",
							"description"           	=> __( "Define the color for the content text.", "ts_visual_composer_extend" ),
							"dependency"            	=> array( 'element' => "effect_style_icons", 'value' => 'ts-hover-effect-zoe' ),
							"group" 			        => "Content",
						),
						array(
							"type"                  	=> "colorpicker",
							"heading"              	 	=> __( "Icons Color", "ts_visual_composer_extend" ),
							"param_name"            	=> "content_color_icons",
							"value"                 	=> "#000000",
							"description"           	=> __( "Define the color for the content icons.", "ts_visual_composer_extend" ),
							"dependency"            	=> array( 'element' => "effect_style_type", 'value' => 'icons' ),
							"group" 			        => "Content",
						),
						array(
							"type"              		=> "icons_panel",
							"heading"           		=> __( "Icon #1", "ts_visual_composer_extend" ),
							"param_name"        		=> "content_link1_icon",
							"value"             		=> $this->TS_VCSC_HoverEffectsIconsSelection,
							"fonts"						=> "false",
							"filter"					=> "false",
							"summary"					=> "false",
							"override"					=> "true",
							"description"       		=> __( "Select the icon you want to display.", "ts_visual_composer_extend" ),
							"dependency"            	=> array( 'element' => "effect_style_icons", 'value' => array("ts-hover-effect-zoe", "ts-hover-effect-hera", "ts-hover-effect-winston", "ts-hover-effect-terry", "ts-hover-effect-phoebe", "ts-hover-effect-kira") ),
							"group" 					=> "Content",
						),
						array(
							"type" 						=> "vc_link",
							"heading" 					=> __("Icon Link + Title #1", "ts_visual_composer_extend"),
							"param_name" 				=> "content_link1",
							"description" 				=> __("Provide a link to another site/page to be used for Icon #1.", "ts_visual_composer_extend"),
							"dependency"            	=> array( 'element' => "effect_style_icons", 'value' => array("ts-hover-effect-zoe", "ts-hover-effect-hera", "ts-hover-effect-winston", "ts-hover-effect-terry", "ts-hover-effect-phoebe", "ts-hover-effect-kira") ),
							"group" 					=> "Content",
						),
						array(
							"type"              		=> "icons_panel",
							"heading"           		=> __( "Icon #2", "ts_visual_composer_extend" ),
							"param_name"        		=> "content_link2_icon",
							"value"             		=> $this->TS_VCSC_HoverEffectsIconsSelection,
							"fonts"						=> "false",
							"filter"					=> "false",
							"summary"					=> "false",
							"override"					=> "true",
							"description"       		=> __( "Select the icon you want to display.", "ts_visual_composer_extend" ),
							"dependency"            	=> array( 'element' => "effect_style_icons", 'value' => array("ts-hover-effect-zoe", "ts-hover-effect-hera", "ts-hover-effect-winston", "ts-hover-effect-terry", "ts-hover-effect-phoebe", "ts-hover-effect-kira") ),
							"group" 					=> "Content",
						),
						array(
							"type" 						=> "vc_link",
							"heading" 					=> __("Icon Link + Title #2", "ts_visual_composer_extend"),
							"param_name" 				=> "content_link2",
							"description" 				=> __("Provide a link to another site/page to be used for Icon #2.", "ts_visual_composer_extend"),
							"dependency"            	=> array( 'element' => "effect_style_icons", 'value' => array("ts-hover-effect-zoe", "ts-hover-effect-hera", "ts-hover-effect-winston", "ts-hover-effect-terry", "ts-hover-effect-phoebe", "ts-hover-effect-kira") ),
							"group" 					=> "Content",
						),
						array(
							"type"              		=> "icons_panel",
							"heading"           		=> __( "Icon #3", "ts_visual_composer_extend" ),
							"param_name"        		=> "content_link3_icon",
							"value"             		=> $this->TS_VCSC_HoverEffectsIconsSelection,
							"fonts"						=> "false",
							"filter"					=> "false",
							"summary"					=> "false",
							"override"					=> "true",
							"description"       		=> __( "Select the icon you want to display.", "ts_visual_composer_extend" ),
							"dependency"            	=> array( 'element' => "effect_style_icons", 'value' => array("ts-hover-effect-zoe", "ts-hover-effect-hera", "ts-hover-effect-winston", "ts-hover-effect-terry", "ts-hover-effect-phoebe", "ts-hover-effect-kira") ),
							"group" 					=> "Content",
						),
						array(
							"type" 						=> "vc_link",
							"heading" 					=> __("Icon Link + Title #3", "ts_visual_composer_extend"),
							"param_name" 				=> "content_link3",
							"description" 				=> __("Provide a link to another site/page to be used for Icon #3.", "ts_visual_composer_extend"),
							"dependency"            	=> array( 'element' => "effect_style_icons", 'value' => array("ts-hover-effect-zoe", "ts-hover-effect-hera", "ts-hover-effect-winston", "ts-hover-effect-terry", "ts-hover-effect-phoebe", "ts-hover-effect-kira") ),
							"group" 					=> "Content",
						),
						array(
							"type"              		=> "icons_panel",
							"heading"           		=> __( "Icon #4", "ts_visual_composer_extend" ),
							"param_name"        		=> "content_link4_icon",
							"value"             		=> $this->TS_VCSC_HoverEffectsIconsSelection,
							"fonts"						=> "false",
							"filter"					=> "false",
							"summary"					=> "false",
							"override"					=> "true",
							"description"       		=> __( "Select the icon you want to display.", "ts_visual_composer_extend" ),
							"dependency"            	=> array( 'element' => "effect_style_icons", 'value' => array("ts-hover-effect-hera", "ts-hover-effect-terry", "ts-hover-effect-kira") ),
							"group" 					=> "Content",
						),
						array(
							"type" 						=> "vc_link",
							"heading" 					=> __("Icon Link + Title #4", "ts_visual_composer_extend"),
							"param_name" 				=> "content_link4",
							"description" 				=> __("Provide a link to another site/page to be used for Icon #4.", "ts_visual_composer_extend"),
							"dependency"            	=> array( 'element' => "effect_style_icons", 'value' => array("ts-hover-effect-hera", "ts-hover-effect-terry", "ts-hover-effect-kira") ),
							"group" 					=> "Content",
						),	
						array(
							"type"             	 		=> "switch",
							"heading"               	=> __( "Show Overlay Handle", "ts_visual_composer_extend" ),
							"param_name"            	=> "overlay_handle_show",
							"value"                 	=> "true",
							"on"						=> __( 'Yes', "ts_visual_composer_extend" ),
							"off"						=> __( 'No', "ts_visual_composer_extend" ),
							"style"						=> "select",
							"design"					=> "toggle-light",
							"description"       		=> __( "Use the toggle to show or hide a handle button below the image.", "ts_visual_composer_extend" ),
							"dependency"        		=> "",
							"group" 			        => "Content",
						),
						array(
							"type"                  	=> "colorpicker",
							"heading"              	 	=> __( "Handle Color", "ts_visual_composer_extend" ),
							"param_name"            	=> "overlay_handle_color",
							"value"                 	=> "#0094FF",
							"description"           	=> __( "Define the color for the overlay handle button.", "ts_visual_composer_extend" ),
							"dependency"            	=> array( 'element' => "overlay_handle_show", 'value' => 'true' ),
							"group" 			        => "Content",
						),
						// Click Events
						array(
							"type"				    	=> "seperator",
							"heading"			    	=> __( "", "ts_visual_composer_extend" ),
							"param_name"		    	=> "seperator_4",
							"value"						=> "",
							"seperator"					=> "Click Event",
							"description"		    	=> __( "", "ts_visual_composer_extend" ),
							"dependency"            	=> "",
							"group" 					=> "Event",
						),
						array(
							"type"              		=> "messenger",
							"heading"           		=> __( "", "ts_visual_composer_extend" ),
							"param_name"        		=> "messenger",
							"color"						=> "#D21515",
							"weight"					=> "bold",
							"size"						=> "14",
							"value"						=> "",
							"message"            		=> __( "Click events are only available for style types with text, but not for styles with icons.", "ts_visual_composer_extend" ),
							"description"       		=> __( "", "ts_visual_composer_extend" ),
							"dependency"            	=> array( 'element' => "effect_style_type", 'value' => 'icons' ),
							"group" 					=> "Event",
						),
						array(
							"type"                  	=> "dropdown",
							"heading"               	=> __( "Click Event", "ts_visual_composer_extend" ),
							"param_name"            	=> "hover_event",
							"width"                 	=> 150,
							"value" 					=> array(
								__( "None", "ts_visual_composer_extend" )									=> "none",
								__( "Open Image in Lightbox", "ts_visual_composer_extend" )					=> "image",
								__( "Open Popup in Lightbox", "ts_visual_composer_extend" )					=> "popup",
								__( "Open YouTube Video in Lightbox", "ts_visual_composer_extend" )			=> "youtube",
								__( "Open Vimeo Video in Lightbox", "ts_visual_composer_extend" )			=> "vimeo",
								__( "Open DailyMotion Video in Lightbox", "ts_visual_composer_extend" )		=> "dailymotion",
								__( "Open Page in iFrame", "ts_visual_composer_extend" )					=> "iframe",
								__( "Simple Link to Page", "ts_visual_composer_extend" )					=> "link",
							),
							"description"           	=> __( "Select if the Hover image should trigger any other action.", "ts_visual_composer_extend" ),
							"admin_label"       		=> true,
							"dependency"            	=> array( 'element' => "effect_style_type", 'value' => 'text' ),
							"group" 					=> "Event",
						),
						// Modal Popup
						array(
							"type"                  	=> "switch",
							"heading"			    	=> __( "Show Hover Title", "ts_visual_composer_extend" ),
							"param_name"		    	=> "hover_show_title",
							"value"                 	=> "true",
							"on"				    	=> __( 'Yes', "ts_visual_composer_extend" ),
							"off"				    	=> __( 'No', "ts_visual_composer_extend" ),
							"style"				    	=> "select",
							"design"			    	=> "toggle-light",
							"description"		    	=> __( "Switch the toggle if you want to show the title in the modal popup.", "ts_visual_composer_extend" ),
							"dependency"            	=> array( 'element' => "hover_event", 'value' => 'popup' ),
							"group" 					=> "Event",
						),
						array(
							"type"              		=> "textarea_raw_html",
							"heading"           		=> __( "Hover Description", "ts_visual_composer_extend" ),
							"param_name"        		=> "hover_text",
							"value"             		=> base64_encode(""),
							"description"       		=> __( "Enter the more detailed description for the modal popup; HTML code can be used.", "ts_visual_composer_extend" ),
							"dependency"        		=> array( 'element' => "hover_event", 'value' => 'popup' ),
							"group" 					=> "Event",
						),
						// YouTube / DailyMotion / Vimeo
						array(
							"type"                  	=> "textfield",
							"heading"               	=> __( "Video URL", "ts_visual_composer_extend" ),
							"param_name"            	=> "hover_video_link",
							"value"                 	=> "",
							"description"           	=> __( "Enter the URL for the video to be shown in a lightbox.", "ts_visual_composer_extend" ),
							"dependency"            	=> array( 'element' => "hover_event", 'value' => array('youtube','dailymotion','vimeo') ),
							"group" 					=> "Event",
						),
						array(
							"type"              		=> "switch",
							"heading"			    	=> __( "Show Related Videos", "ts_visual_composer_extend" ),
							"param_name"		    	=> "hover_video_related",
							"value"             		=> "false",
							"on"						=> __( 'Yes', "ts_visual_composer_extend" ),
							"off"						=> __( 'No', "ts_visual_composer_extend" ),
							"style"						=> "select",
							"design"					=> "toggle-light",
							"description"		    	=> __( "Switch the toggle if you want to show related videos once the video has finished playing.", "ts_visual_composer_extend" ),
							"dependency"            	=> array( 'element' => "hover_event", 'value' => 'youtube' ),
							"group" 					=> "Event",
						),
						array(
							"type"              		=> "switch",
							"heading"			    	=> __( "Autoplay Video", "ts_visual_composer_extend" ),
							"param_name"		    	=> "hover_video_auto",
							"value"             		=> "true",
							"on"						=> __( 'Yes', "ts_visual_composer_extend" ),
							"off"						=> __( 'No', "ts_visual_composer_extend" ),
							"style"						=> "select",
							"design"					=> "toggle-light",
							"description"		    	=> __( "Switch the toggle if you want to auto-play the video once opened in the lightbox.", "ts_visual_composer_extend" ),
							"dependency"            	=> array( 'element' => "hover_event", 'value' => array('youtube','dailymotion','vimeo') ),
							"group" 					=> "Event",
						),
						// Link / iFrame
						array(
							"type" 						=> "vc_link",
							"heading" 					=> __("Link + Title", "ts_visual_composer_extend"),
							"param_name" 				=> "hover_link",
							"description" 				=> __("Provide a link to another site/page to be used for the Hover event.", "ts_visual_composer_extend"),
							"dependency"            	=> array( 'element' => "hover_event", 'value' => array('iframe','link') ),
							"group" 					=> "Event",
						),
						// Tooltip Settings
						array(
							"type"						=> "seperator",
							"heading"					=> __( "", "ts_visual_composer_extend" ),
							"param_name"				=> "seperator_4",
							"value"						=> "",
							"seperator"					=> "Tooltip Settings",
							"description"				=> __( "", "ts_visual_composer_extend" ),
							"group" 					=> "Tooltip",
						),
						array(
							"type"                  	=> "switch",
							"heading"			    	=> __( "Use HTML in Tooltip", "ts_visual_composer_extend" ),
							"param_name"		    	=> "tooltip_html",
							"value"                 	=> "false",
							"on"				    	=> __( 'Yes', "ts_visual_composer_extend" ),
							"off"				    	=> __( 'No', "ts_visual_composer_extend" ),
							"style"				    	=> "select",
							"design"			    	=> "toggle-light",
							"description"		    	=> __( "Switch the toggle if you want to allow basic HTML code for the tooltip content.", "ts_visual_composer_extend" ),
							"dependency"            	=> "",
							"group" 					=> "Tooltip",
						),
						array(
							"type"						=> "textarea",
							"class"						=> "",
							"heading"					=> __( "Tooltip Content", "ts_visual_composer_extend" ),
							"param_name"				=> "tooltip_content",
							"value"						=> "",
							"description"		    	=> __( "Enter the tooltip content here (do not use quotation marks or HTML code).", "ts_visual_composer_extend" ),
							"dependency"        		=> array( 'element' => "tooltip_html", 'value' => 'false' ),
							"group" 					=> "Tooltip",
						),
						array(
							"type"              		=> "textarea_raw_html",
							"heading"           		=> __( "Tooltip Content", "ts_visual_composer_extend" ),
							"param_name"        		=> "tooltip_content_html",
							"value"             		=> base64_encode(""),
							"description"      	 		=> __( "Enter the tooltip content here; HTML code can be used.", "ts_visual_composer_extend" ),
							"dependency"        		=> array( 'element' => "tooltip_html", 'value' => 'true' ),
							"group" 					=> "Tooltip",
						),
						array(
							"type"						=> "dropdown",
							"class"						=> "",
							"heading"					=> __( "Tooltip Style", "ts_visual_composer_extend" ),
							"param_name"				=> "tooltip_style",
							"value"             		=> array(
								__( "Black", "ts_visual_composer_extend" )                          => "",
								__( "Gray", "ts_visual_composer_extend" )                           => "ts-simptip-style-gray",
								__( "Green", "ts_visual_composer_extend" )                          => "ts-simptip-style-green",
								__( "Blue", "ts_visual_composer_extend" )                           => "ts-simptip-style-blue",
								__( "Red", "ts_visual_composer_extend" )                            => "ts-simptip-style-red",
								__( "Orange", "ts_visual_composer_extend" )                         => "ts-simptip-style-orange",
								__( "Yellow", "ts_visual_composer_extend" )                         => "ts-simptip-style-yellow",
								__( "Purple", "ts_visual_composer_extend" )                         => "ts-simptip-style-purple",
								__( "Pink", "ts_visual_composer_extend" )                           => "ts-simptip-style-pink",
								__( "White", "ts_visual_composer_extend" )                          => "ts-simptip-style-white"
							),
							"description"				=> __( "Select the tooltip style.", "ts_visual_composer_extend" ),
							"group" 					=> "Tooltip",
						),
						array(
							"type"						=> "nouislider",
							"heading"					=> __( "Tooltip X-Offset", "ts_visual_composer_extend" ),
							"param_name"				=> "tooltipster_offsetx",
							"value"						=> "0",
							"min"						=> "-100",
							"max"						=> "100",
							"step"						=> "1",
							"unit"						=> 'px',
							"description"				=> __( "Define an optional X-Offset for the tooltip position.", "ts_visual_composer_extend" ),
							"group" 					=> "Tooltip",
						),
						array(
							"type"						=> "nouislider",
							"heading"					=> __( "Tooltip Y-Offset", "ts_visual_composer_extend" ),
							"param_name"				=> "tooltipster_offsety",
							"value"						=> "0",
							"min"						=> "-100",
							"max"						=> "100",
							"step"						=> "1",
							"unit"						=> 'px',
							"description"				=> __( "Define an optional Y-Offset for the tooltip position.", "ts_visual_composer_extend" ),
							"group" 					=> "Tooltip",
						),	
                        // Other Settings
                        array(
                            "type"                      => "seperator",
                            "heading"                   => __( "", "ts_visual_composer_extend" ),
                            "param_name"                => "seperator_5",
							"value"						=> "",
                            "seperator"					=> "Other Settings",
                            "description"               => __( "", "ts_visual_composer_extend" ),
                            "group" 			        => "Other Settings",
                        ),
                        array(
                            "type"                      => "nouislider",
                            "heading"                   => __( "Margin: Top", "ts_visual_composer_extend" ),
                            "param_name"                => "margin_top",
                            "value"                     => "0",
                            "min"                       => "-50",
                            "max"                       => "500",
                            "step"                      => "1",
                            "unit"                      => 'px',
                            "description"               => __( "Select the top margin for the element.", "ts_visual_composer_extend" ),
                            "group" 			        => "Other Settings",
                        ),
                        array(
                            "type"                      => "nouislider",
                            "heading"                   => __( "Margin: Bottom", "ts_visual_composer_extend" ),
                            "param_name"                => "margin_bottom",
                            "value"                     => "0",
                            "min"                       => "-50",
                            "max"                       => "500",
                            "step"                      => "1",
                            "unit"                      => 'px',
                            "description"               => __( "Select the bottom margin for the element.", "ts_visual_composer_extend" ),
                            "group" 			        => "Other Settings",
                        ),
                        array(
                            "type"                      => "textfield",
                            "heading"                   => __( "Define ID Name", "ts_visual_composer_extend" ),
                            "param_name"                => "el_id",
                            "value"                     => "",
                            "description"               => __( "Enter an unique ID for the element.", "ts_visual_composer_extend" ),
                            "group" 			        => "Other Settings",
                        ),
                        array(
                            "type"                      => "textfield",
                            "heading"                   => __( "Extra Class Name", "ts_visual_composer_extend" ),
                            "param_name"                => "el_class",
                            "value"                     => "",
                            "description"               => __( "Enter a class name for the element.", "ts_visual_composer_extend" ),
                            "group" 			        => "Other Settings",
                        ),
                        // Load Custom CSS/JS File
                        array(
                            "type"                      => "load_file",
                            "heading"                   => __( "", "ts_visual_composer_extend" ),
                            "param_name"                => "el_file",
                            "value"                     => "",
                            "file_type"                 => "js",
                            "file_path"                 => "js/ts-visual-composer-extend-element.min.js",
                            "description"               => __( "", "ts_visual_composer_extend" )
                        ),
                    ))
                );
            }
        }
	}
}
if (class_exists('WPBakeryShortCode')) {
	class WPBakeryShortCode_TS_Image_Hover_Effects extends WPBakeryShortCode {};
}
// Initialize "TS Image Hover Effects" Class
if (class_exists('TS_Image_Hover_Effects')) {
	$TS_Image_Hover_Effects = new TS_Image_Hover_Effects;
}