<?php
    if (function_exists('vc_map')) {
        vc_map( array(
            "name"                          => __( "TS Modal Popup", "ts_visual_composer_extend" ),
            "base"                          => "TS-VCSC-Modal-Popup",
            "icon" 	                        => "icon-wpb-ts_vcsc_modal_popup",
            "class"                         => "",
            "category"                      => __( "VC Extensions", "ts_visual_composer_extend" ),
            "description"                   => __("Place a modal popup element", "ts_visual_composer_extend"),
            "admin_enqueue_js"              => "",
            "admin_enqueue_css"             => "",
            "params"                        => array(
                // Modal Settings
                array(
                    "type"                  => "seperator",
                    "heading"               => __( "", "ts_visual_composer_extend" ),
                    "param_name"            => "seperator_1",
					"value"					=> "",
                    "seperator"             => "Modal Popup Settings",
                    "description"           => __( "", "ts_visual_composer_extend" )
                ),
                array(
                    "type"                  => "dropdown",
                    "heading"               => __( "Transition Effect", "ts_visual_composer_extend" ),
                    "param_name"            => "lightbox_effect",
                    "width"                 => 150,
                    "value"                 => array(
                        __( 'Random', "ts_visual_composer_extend" )       => "random",
                        __( 'Swipe', "ts_visual_composer_extend" )        => "swipe",
                        __( 'Fade', "ts_visual_composer_extend" )         => "fade",
                        __( 'Scale', "ts_visual_composer_extend" )        => "scale",
                        __( 'Slide Up', "ts_visual_composer_extend" )     => "slideUp",
                        __( 'Slide Down', "ts_visual_composer_extend" )   => "slideDown",
                        __( 'Flip', "ts_visual_composer_extend" )         => "flip",
                        __( 'Skew', "ts_visual_composer_extend" )         => "skew",
                        __( 'Bounce Up', "ts_visual_composer_extend" )    => "bounceUp",
                        __( 'Bounce Down', "ts_visual_composer_extend" )  => "bounceDown",
                        __( 'Break In', "ts_visual_composer_extend" )     => "breakIn",
                        __( 'Rotate In', "ts_visual_composer_extend" )    => "rotateIn",
                        __( 'Rotate Out', "ts_visual_composer_extend" )   => "rotateOut",
                        __( 'Hang Left', "ts_visual_composer_extend" )    => "hangLeft",
                        __( 'Hang Right', "ts_visual_composer_extend" )   => "hangRight",
                        __( 'Cycle Up', "ts_visual_composer_extend" )     => "cicleUp",
                        __( 'Cycle Down', "ts_visual_composer_extend" )   => "cicleDown",
                        __( 'Zoom In', "ts_visual_composer_extend" )      => "zoomIn",
                        __( 'Throw In', "ts_visual_composer_extend" )     => "throwIn",
                        __( 'Fall', "ts_visual_composer_extend" )         => "fall",
                        __( 'Jump', "ts_visual_composer_extend" )         => "jump",
                    ),
                    "admin_label"           => true,
                    "description"           => __( "Select the transition effect to be used for the image in the lightbox.", "ts_visual_composer_extend" ),
                    "dependency"            => ""
                ),
                array(
                    "type"                  => "dropdown",
                    "heading"               => __( "Backlight Color", "ts_visual_composer_extend" ),
                    "param_name"            => "lightbox_backlight_choice",
                    "width"                 => 150,
                    "value"                 => array(
                        __( 'Predefined Color', "ts_visual_composer_extend" )	=> "predefined",
						__( 'Custom Color', "ts_visual_composer_extend" )		=> "customized",
                    ),
                    "description"           => __( "Select the (backlight) color style for the popup box.", "ts_visual_composer_extend" ),
                    "dependency"            => ""
                ),
                array(
                    "type"                  => "dropdown",
                    "heading"               => __( "Select Backlight Color", "ts_visual_composer_extend" ),
                    "param_name"            => "lightbox_backlight_color",
                    "width"                 => 150,
                    "value"                 => array(
                        __( 'Default', "ts_visual_composer_extend" )      		=> "#0084E2",
                        __( 'Neutral', "ts_visual_composer_extend" )      		=> "#FFFFFF",
                        __( 'Success', "ts_visual_composer_extend" )      		=> "#4CFF00",
                        __( 'Warning', "ts_visual_composer_extend" )      		=> "#EA5D00",
                        __( 'Error', "ts_visual_composer_extend" )        		=> "#CC0000",
                        __( 'None', "ts_visual_composer_extend" )         		=> "#000000",
                    ),
                    "description"           => __( "Select the predefined backlight color for the modal popup.", "ts_visual_composer_extend" ),
                    "dependency"            => array( 'element' => "lightbox_backlight_choice", 'value' => 'predefined' )
                ),
				array(
					"type"              	=> "colorpicker",
					"heading"           	=> __( "Select Backlight Color", "ts_visual_composer_extend" ),
					"param_name"        	=> "lightbox_backlight_custom",
					"value"             	=> "#000000",
					"description"       	=> __( "Define a custom backlight color for the modal popup.", "ts_visual_composer_extend" ),
					"dependency"            => array( 'element' => "lightbox_backlight_choice", 'value' => 'customized' )
				),
                array(
                    "type"                  => "switch",
					"heading"			    => __( "Show on Page Load", "ts_visual_composer_extend" ),
					"param_name"		    => "content_open",
                    "value"                 => "false",
                    "on"				    => __( 'Yes', "ts_visual_composer_extend" ),
                    "off"				    => __( 'No', "ts_visual_composer_extend" ),
                    "style"				    => "select",
                    "design"			    => "toggle-light",
					"admin_label"           => true,
					"description"		    => __( "Switch the toggle if you want show the popup on page load (limit to one per page).", "ts_visual_composer_extend" ),
                    "dependency"            => ""
                ),
                array(
                    "type"                  => "switch",
					"heading"			    => __( "Hide Popup Trigger on Page", "ts_visual_composer_extend" ),
					"param_name"		    => "content_open_hide",
                    "value"                 => "false",
                    "on"				    => __( 'Yes', "ts_visual_composer_extend" ),
                    "off"				    => __( 'No', "ts_visual_composer_extend" ),
                    "style"				    => "select",
                    "design"			    => "toggle-light",
					"description"		    => __( "Switch the toggle if you want show or hide the popup trigger on the page.", "ts_visual_composer_extend" ),
                    "dependency"            => array( 'element' => "content_open", 'value' => 'true' )
                ),
                array(
                    "type"                  => "nouislider",
                    "heading"               => __( "Time Delay", "ts_visual_composer_extend" ),
                    "param_name"            => "content_open_delay",
                    "value"                 => "0",
                    "min"                   => "0",
                    "max"                   => "10000",
                    "step"                  => "100",
                    "unit"                  => 'ms',
                    "description"           => __( "Define the delay in ms until the modal popup should be shown (starting from 'Document Ready').", "ts_visual_composer_extend" ),
                    "dependency"            => array( 'element' => "content_open", 'value' => 'true' )
                ),
                // Custom Settings
                array(
                    "type"                  => "seperator",
                    "heading"               => __( "", "ts_visual_composer_extend" ),
                    "param_name"            => "seperator_2",
					"value"					=> "",
                    "seperator"             => "Custom Settings",
                    "description"           => __( "", "ts_visual_composer_extend" )
                ),
                /*array(
                    "type"                  => "nouislider",
                    "heading"               => __( "Custom Padding", "ts_visual_composer_extend" ),
                    "param_name"            => "lightbox_custom_padding",
                    "value"                 => "15",
                    "min"                   => "0",
                    "max"                   => "50",
                    "step"                  => "1",
                    "unit"                  => 'px',
                    "description"           => __( "Define a custom padding for the modal popup in order to create a simple frame effect.", "ts_visual_composer_extend" ),
                ),		
                array(
                    "type"                  => "switch",
					"heading"			    => __( "Custom Width", "ts_visual_composer_extend" ),
					"param_name"		    => "lightbox_custom_width",
                    "value"                 => "false",
                    "on"				    => __( 'Yes', "ts_visual_composer_extend" ),
                    "off"				    => __( 'No', "ts_visual_composer_extend" ),
                    "style"				    => "select",
                    "design"			    => "toggle-light",
					"description"		    => __( "Switch the toggle if you want to apply a custom width to the modal popup element (will otherwise be determined by script).", "ts_visual_composer_extend" ),
                    "dependency"            => ""
                ),
                array(
                    "type"                  => "nouislider",
                    "heading"               => __( "Custom Width", "ts_visual_composer_extend" ),
                    "param_name"            => "lightbox_width",
                    "value"                 => "960",
                    "min"                   => "400",
                    "max"                   => "2160",
                    "step"                  => "1",
                    "unit"                  => 'px',
                    "description"           => __( "Define the custom width for the modal popup (script will adjust if necessary, based on actual screen size).", "ts_visual_composer_extend" ),
                    "dependency"            => array( 'element' => "lightbox_custom_width", 'value' => 'true' )
                ),
                array(
                    "type"                  => "switch",
					"heading"			    => __( "Custom Height", "ts_visual_composer_extend" ),
					"param_name"		    => "lightbox_custom_height",
                    "value"                 => "false",
                    "on"				    => __( 'Yes', "ts_visual_composer_extend" ),
                    "off"				    => __( 'No', "ts_visual_composer_extend" ),
                    "style"				    => "select",
                    "design"			    => "toggle-light",
					"description"		    => __( "Switch the toggle if you want to apply a custom height to the modal popup element (will otherwise be determined by script).", "ts_visual_composer_extend" ),
                    "dependency"            => ""
                ),
                array(
                    "type"                  => "nouislider",
                    "heading"               => __( "Custom Height", "ts_visual_composer_extend" ),
                    "param_name"            => "lightbox_height",
                    "value"                 => "540",
                    "min"                   => "300",
                    "max"                   => "1440",
                    "step"                  => "1",
                    "unit"                  => 'px',
                    "description"           => __( "Define the custom height for the modal popup (script will adjust if necessary, based on actual screen size).", "ts_visual_composer_extend" ),
                    "dependency"            => array( 'element' => "lightbox_custom_height", 'value' => 'true' )
                ),*/	
                array(
                    "type"                  => "dropdown",
                    "heading"               => __( "Custom Background", "ts_visual_composer_extend" ),
                    "param_name"            => "lightbox_custom_background",
                    "width"                 => 150,
                    "value"                 => array(
                        __( 'None', "ts_visual_composer_extend" )      		=> "none",
                        __( 'Image', "ts_visual_composer_extend" )      	=> "image",
                        __( 'Color', "ts_visual_composer_extend" )      	=> "color",
                    ),
                    "description"           => __( "Select if you want to add a custom background to the modal popup element.", "ts_visual_composer_extend" ),
                    "dependency"            => ""
                ),
				array(
					"type"                  => "attach_image",
					"heading"               => __( "Background Image", "ts_visual_composer_extend" ),
					"param_name"            => "lightbox_background_image",
					"value"                 => "",
					"description"           => __( "Select the background image for the modal popup element.", "ts_visual_composer_extend" ),
					"dependency"            => array( 'element' => "lightbox_custom_background", 'value' => 'image' ),
				),
                array(
                    "type"                  => "dropdown",
                    "heading"               => __( "Background Size", "ts_visual_composer_extend" ),
                    "param_name"            => "lightbox_background_size",
                    "width"                 => 150,
					"value" 				=> array(
						__( "Cover", "ts_visual_composer_extend" ) 			=> "cover",
						__( "150%", "ts_visual_composer_extend" )			=> "150%",
						__( "200%", "ts_visual_composer_extend" )			=> "200%",
						__( "Contain", "ts_visual_composer_extend" ) 		=> "contain",
						__( "Initial", "ts_visual_composer_extend" ) 		=> "initial",
						__( "Auto", "ts_visual_composer_extend" ) 			=> "auto",
					),
                    "description"           => __( "Select how the custom background image should be sized.", "ts_visual_composer_extend" ),
                    "dependency"            => array( 'element' => "lightbox_custom_background", 'value' => 'image' ),
                ),
                array(
                    "type"                  => "dropdown",
                    "heading"               => __( "Background Repeat", "ts_visual_composer_extend" ),
                    "param_name"            => "lightbox_background_repeat",
                    "width"                 => 150,
					"value" 				=> array(
						__( "No Repeat", "ts_visual_composer_extend" )		=> "no-repeat",
						__( "Repeat X + Y", "ts_visual_composer_extend" )	=> "repeat",
						__( "Repeat X", "ts_visual_composer_extend" )		=> "repeat-x",
						__( "Repeat Y", "ts_visual_composer_extend" )		=> "repeat-y"
					),
                    "description"           => __( "Select if and how the background image should be repeated.", "ts_visual_composer_extend" ),
                    "dependency"            => array( 'element' => "lightbox_custom_background", 'value' => 'image' ),
                ),				
				array(
					"type"              	=> "colorpicker",
					"heading"           	=> __( "Background Color", "ts_visual_composer_extend" ),
					"param_name"        	=> "lightbox_background_color",
					"value"             	=> "#ffffff",
					"description"       	=> __( "Define a custom background color for the modal popup element.", "ts_visual_composer_extend" ),
					"dependency"            => array( 'element' => "lightbox_custom_background", 'value' => 'color' )
				),		
                // Modal Triggger
				array(
					"type"				    => "seperator",
					"heading"			    => __( "", "ts_visual_composer_extend" ),
					"param_name"		    => "seperator_3",
					"value"					=> "",
					"seperator"				=> "Modal Popup Trigger",
					"description"		    => __( "", "ts_visual_composer_extend" ),
                    "dependency"            => "",
					"group" 				=> "Trigger Settings",
				),
				array(
					"type"                  => "dropdown",
					"heading"               => __( "Trigger Type", "ts_visual_composer_extend" ),
					"param_name"            => "content_trigger",
                    "value"                 => array(
                        __("Default Image", "ts_visual_composer_extend")          => "default",
                        __("Custom Image", "ts_visual_composer_extend")           => "image",
                        __("Font Icon", "ts_visual_composer_extend")              => "icon",
                        __("Winged Button", "ts_visual_composer_extend")          => "winged",
                        __("Simple Button", "ts_visual_composer_extend")          => "simple",
                        __("Text", "ts_visual_composer_extend")                   => "text",
                        __("Custom HTML", "ts_visual_composer_extend")            => "custom",
                    ),
                    "admin_label"           => true,
					"description"           => __( "Select the type of trigger to click on in order to show the lightbox.", "ts_visual_composer_extend" ),
					"dependency"            => "",
					"group" 				=> "Trigger Settings",
				),
                // Custom Image
				array(
					"type"                  => "attach_image",
					"heading"               => __( "Select Image", "ts_visual_composer_extend" ),
					"param_name"            => "content_image",
					"value"                 => "",
					"description"           => __( "Select the preview image for the modal popup.", "ts_visual_composer_extend" ),
					"dependency"            => array( 'element' => "content_trigger", 'value' => 'image' ),
					"group" 				=> "Trigger Settings",
				),
                array(
                    "type"                  => "switch",
					"heading"			    => __( "Simple Image Only", "ts_visual_composer_extend" ),
					"param_name"		    => "content_image_simple",
                    "value"                 => "false",
                    "on"				    => __( 'Yes', "ts_visual_composer_extend" ),
                    "off"				    => __( 'No', "ts_visual_composer_extend" ),
                    "style"				    => "select",
                    "design"			    => "toggle-light",
					"description"		    => __( "Switch the toggle if you want display just the image without any styling.", "ts_visual_composer_extend" ),
                    "dependency"            => array( 'element' => "content_trigger", 'value' => 'image' ),
					"group" 				=> "Trigger Settings",
                ),
                array(
                    "type"                  => "dropdown",
                    "heading"               => __( "Auto Height Setting", "ts_visual_composer_extend" ),
                    "param_name"            => "content_image_height",
                    "width"                 => 150,
                    "value"                 => array(
                        __( '100% Height Setting', "ts_visual_composer_extend" )		=> "height: 100%;",
                        __( 'Auto Height Setting', "ts_visual_composer_extend" )     	=> "height: auto;",
                    ),
                    "description"           => __( "Select what CSS height setting should be applied to the image (change only if image height does not display correctly).", "ts_visual_composer_extend" ),
                    "dependency"            => array( 'element' => "content_trigger", 'value' => array('default', 'image') ),
					"group" 				=> "Trigger Settings",
                ),
                // Font Icon
				array(
					"type"                  => "icons_panel",
					"heading"               => __( "Select Icon", "ts_visual_composer_extend" ),
					"param_name"            => "content_icon",
					"value"                 => $this->TS_VCSC_List_Icons_Full,
					"description"           => __( "Select the icon you want to display.", "ts_visual_composer_extend" ),
					"dependency"            => array( 'element' => "content_trigger", 'value' => 'icon' ),
					"group" 				=> "Trigger Settings",
				),
				array(
					"type"                  => "nouislider",
					"heading"               => __( "Icon Size", "ts_visual_composer_extend" ),
					"param_name"            => "content_iconsize",
					"value"                 => "30",
					"min"                   => "16",
					"max"                   => "512",
					"step"                  => "1",
					"unit"                  => 'px',
					"description"           => __( "Select the icon size", "ts_visual_composer_extend" ),
					"dependency"            => array( 'element' => "content_trigger", 'value' => 'icon' ),
					"group" 				=> "Trigger Settings",
				),
				array(
					"type"                  => "colorpicker",
					"heading"               => __( "Icon Color", "ts_visual_composer_extend" ),
					"param_name"            => "content_iconcolor",
					"value"                 => "#cccccc",
					"description"           => __( "Define the color of the icon.", "ts_visual_composer_extend" ),
					"dependency"            => array( 'element' => "content_trigger", 'value' => 'icon' ),
					"group" 				=> "Trigger Settings",
				),
                // Button
                array(
                    "type"                  => "textfield",
                    "heading"               => __( "Button Text", "ts_visual_composer_extend" ),
                    "param_name"            => "content_buttontext",
                    "value"                 => "View Popup",
                    "description"           => __( "Enter the text for the button.", "ts_visual_composer_extend" ),
                    "dependency"            => array( 'element' => "content_trigger", 'value' => array('winged', 'simple') ),
					"group" 				=> "Trigger Settings",
                ),
                // Text Link
                array(
                    "type"                  => "textfield",
                    "heading"               => __( "Trigger Text", "ts_visual_composer_extend" ),
                    "param_name"            => "content_text",
                    "value"                 => "",
                    "description"           => __( "Enter the trigger text for the modal popup.", "ts_visual_composer_extend" ),
                    "dependency"            => array( 'element' => "content_trigger", 'value' => 'text' ),
					"group" 				=> "Trigger Settings",
                ),
                // Custom Code
                array(
                    "type"                  => "textarea_raw_html",
                    "heading"               => __("Raw HTML", "ts_visual_composer_extend"),
                    "param_name"            => "content_raw",
                    "value"                 => base64_encode(""),
                    "description"           => __("Enter your custom HTML code; code will be wrapped in appropriate link automatically.", "ts_visual_composer_extend"),
                    "dependency"            => array( 'element' => "content_trigger", 'value' => 'custom' ),
					"group" 				=> "Trigger Settings",
                ),
                // Title + Subtitle
                array(
                    "type"                  => "textfield",
                    "heading"               => __( "Title", "ts_visual_composer_extend" ),
                    "param_name"            => "content_title",
                    "value"                 => "",
                    "description"           => __( "Enter a title for the modal popup trigger.", "ts_visual_composer_extend" ),
                    "dependency"            => array( 'element' => "content_trigger", 'value' => array('image', 'default', 'simple', 'winged', 'icon', 'text', 'custom') ),
					"group" 				=> "Trigger Settings",
                ),
                array(
                    "type"                  => "textfield",
                    "heading"               => __( "Subtitle", "ts_visual_composer_extend" ),
                    "param_name"            => "content_subtitle",
                    "value"                 => "",
                    "description"           => __( "Enter a subtitle for the modal popup trigger.", "ts_visual_composer_extend" ),
                    "dependency"            => array( 'element' => "content_trigger", 'value' => array('winged') ),
					"group" 				=> "Trigger Settings",
                ),
                // Tooltip Settings
				array(
					"type"				    => "seperator",
					"heading"			    => __( "", "ts_visual_composer_extend" ),
					"param_name"		    => "seperator_5",
					"value"					=> "",
					"seperator"				=> "Trigger Tooltip",
					"description"		    => __( "", "ts_visual_composer_extend" ),
                    "dependency"            => array( 'element' => "content_trigger", 'value' => array('image', 'default', 'simple', 'icon', 'text', 'custom') ),
					"group" 				=> "Trigger Settings",
				),
                array(
                    "type"                  => "switch",
					"heading"			    => __( "Use Advanced Tooltip", "ts_visual_composer_extend" ),
					"param_name"		    => "content_tooltip_css",
                    "value"                 => "false",
                    "on"				    => __( 'Yes', "ts_visual_composer_extend" ),
                    "off"				    => __( 'No', "ts_visual_composer_extend" ),
                    "style"				    => "select",
                    "design"			    => "toggle-light",
					"description"		    => __( "Switch the toggle if you want to apply am advanced tooltip to the image.", "ts_visual_composer_extend" ),
                    "dependency"            => array( 'element' => "content_trigger", 'value' => array('image', 'default', 'simple', 'icon', 'text', 'custom') ),
					"group" 				=> "Trigger Settings",
                ),
				array(
					"type"				    => "textarea",
					"class"				    => "",
					"heading"			    => __( "Tooltip Content", "ts_visual_composer_extend" ),
					"param_name"		    => "content_tooltip_content",
					"value"				    => "",
					"description"		    => __( "Enter the tooltip content here (do not use quotation marks).", "ts_visual_composer_extend" ),
                    "dependency"            => array( 'element' => "content_trigger", 'value' => array('image', 'default', 'simple', 'icon', 'text', 'custom') ),
					"group" 				=> "Trigger Settings",
				),
				array(
					"type"				    => "dropdown",
					"class"				    => "",
					"heading"			    => __( "Tooltip Position", "ts_visual_composer_extend" ),
					"param_name"		    => "content_tooltip_position",
                    "value"                 => array(
                        __("Top", "ts_visual_composer_extend")                    => "ts-simptip-position-top",
                        __("Bottom", "ts_visual_composer_extend")                 => "ts-simptip-position-bottom",
                    ),
					"description"		    => __( "Select the tooltip position in relation to the image.", "ts_visual_composer_extend" ),
					"dependency"		    => array( 'element' => "content_tooltip_css", 'value' => 'true' ),
					"group" 				=> "Trigger Settings",
				),
				array(
					"type"				    => "dropdown",
					"class"				    => "",
					"heading"			    => __( "Tooltip Style", "ts_visual_composer_extend" ),
					"param_name"		    => "content_tooltip_style",
                    "value"                 => array(
                        __("Black", "ts_visual_composer_extend")                  => "",
                        __("Gray", "ts_visual_composer_extend")                   => "ts-simptip-style-gray",
                        __("Green", "ts_visual_composer_extend")                  => "ts-simptip-style-green",
                        __("Blue", "ts_visual_composer_extend")                   => "ts-simptip-style-blue",
                        __("Red", "ts_visual_composer_extend")                    => "ts-simptip-style-red",
                        __("Orange", "ts_visual_composer_extend")                 => "ts-simptip-style-orange",
                        __("Yellow", "ts_visual_composer_extend")                 => "ts-simptip-style-yellow",
                        __("Purple", "ts_visual_composer_extend")                 => "ts-simptip-style-purple",
                        __("Pink", "ts_visual_composer_extend")                   => "ts-simptip-style-pink",
                        __("White", "ts_visual_composer_extend")                  => "ts-simptip-style-white"
                    ),
					"description"		    => __( "Select the tooltip style.", "ts_visual_composer_extend" ),
					"dependency"		    => array( 'element' => "content_tooltip_css", 'value' => 'true' ),
					"group" 				=> "Trigger Settings",
				),
                // Modal Content
				array(
					"type"				    => "seperator",
					"heading"			    => __( "", "ts_visual_composer_extend" ),
					"param_name"		    => "seperator_6",
					"value"					=> "",
					"seperator"				=> "Modal Popup Content",
					"description"		    => __( "", "ts_visual_composer_extend" ),
                    "dependency"            => "",
					"group" 				=> "Content Settings",
				),
                array(
                    "type"                  => "switch",
					"heading"			    => __( "Show Modal Title", "ts_visual_composer_extend" ),
					"param_name"		    => "content_show_title",
                    "value"                 => "true",
                    "on"				    => __( 'Yes', "ts_visual_composer_extend" ),
                    "off"				    => __( 'No', "ts_visual_composer_extend" ),
                    "style"				    => "select",
                    "design"			    => "toggle-light",
					"description"		    => __( "Switch the toggle if you want show a title in the modal popup.", "ts_visual_composer_extend" ),
                    "dependency"            => "",
					"group" 				=> "Content Settings",
                ),
                array(
                    "type"                  => "textfield",
                    "heading"               => __( "Modal Title", "ts_visual_composer_extend" ),
                    "param_name"            => "title",
                    "value"                 => "",
                    "description"           => __( "Enter the title for the modal popup.", "ts_visual_composer_extend" ),
                    "dependency"            => array( 'element' => "content_show_title", 'value' => 'true' ),
					"group" 				=> "Content Settings",
                ),
                array(
                    "type"		            => "textarea_html",
                    "class"		            => "",
                    "heading"               => __( "Modal Content", "ts_visual_composer_extend" ),
                    "param_name"            => "content",
                    "value"                 => "",
                    "admin_label"           => false,
                    "description"           => __( "Create the content for the modal popup.", "ts_visual_composer_extend" ),
                    "dependency"            => "",
					"group" 				=> "Content Settings",
                ),
				// Other Settings
				array(
					"type"				    => "seperator",
					"heading"			    => __( "", "ts_visual_composer_extend" ),
					"param_name"		    => "seperator_7",
					"value"					=> "",
					"seperator"				=> "Other Settings",
					"description"		    => __( "", "ts_visual_composer_extend" ),
                    "dependency"            => "",
					"group" 				=> "Other Settings",
				),
                array(
                    "type"                  => "nouislider",
                    "heading"               => __( "Margin: Top", "ts_visual_composer_extend" ),
                    "param_name"            => "margin_top",
                    "value"                 => "0",
                    "min"                   => "0",
                    "max"                   => "200",
                    "step"                  => "1",
                    "unit"                  => 'px',
                    "description"           => __( "Select the top margin for the element.", "ts_visual_composer_extend" ),
					"group" 				=> "Other Settings",
                ),
                array(
                    "type"                  => "nouislider",
                    "heading"               => __( "Margin: Bottom", "ts_visual_composer_extend" ),
                    "param_name"            => "margin_bottom",
                    "value"                 => "0",
                    "min"                   => "0",
                    "max"                   => "200",
                    "step"                  => "1",
                    "unit"                  => 'px',
                    "description"           => __( "Select the bottom margin for the element.", "ts_visual_composer_extend" ),
					"group" 				=> "Other Settings",
                ),
				array(
					"type"                  => "textfield",
					"heading"               => __( "Define ID Name", "ts_visual_composer_extend" ),
					"param_name"            => "el_id",
					"value"                 => "",
					"description"           => __( "Enter an unique ID for the element.", "ts_visual_composer_extend" ),
					"group" 				=> "Other Settings",
				),
				array(
					"type"                  => "textfield",
					"heading"               => __( "Extra Class Name", "ts_visual_composer_extend" ),
					"param_name"            => "el_class",
					"value"                 => "",
					"description"           => __( "Enter a class name for the element.", "ts_visual_composer_extend" ),
					"group" 				=> "Other Settings",
				),
				// Load Custom CSS/JS File
				array(
					"type"                  => "load_file",
					"heading"               => __( "", "ts_visual_composer_extend" ),
                    "param_name"            => "el_file",
					"value"                 => "",
					"file_type"             => "js",
					"file_path"             => "js/ts-visual-composer-extend-element.min.js",
					"description"           => __( "", "ts_visual_composer_extend" )
				),
            ))
        );
    }
?>